Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## sim.field.grid
Class DoubleGrid3D

    java.lang.Object
      sim.field.grid.AbstractGrid3D
          sim.field.grid.DoubleGrid3D

All Implemented Interfaces:
  java.io.Serializable, Grid3D

    public class DoubleGrid3D

extends AbstractGrid3D

A wrapper for 3D arrays of doubles.

This object expects that the 3D arrays are rectangular. You are encouraged to access the array directly. The object implements all of the Grid3D interface. See Grid3D for rules on how to properly implement toroidal grids.

The width and height and length (z dimension) of the object are provided to avoid having to say field[x].length, etc.

See Also:
  Serialized Form

Field Summary
`double[][][]` | `field`

Fields inherited from class sim.field.grid.AbstractGrid3D
`height, length, width`

Fields inherited from interface sim.field.grid.Grid3D
`ALL, ANY, ANY_SIZE, BOUNDED, CENTER, TOROIDAL, UNBOUNDED`

Constructor Summary
`DoubleGrid3D(DoubleGrid3D values)`
`DoubleGrid3D(int width, int height, int length)`
`DoubleGrid3D(int width, int height, int length, double initialValue)`

Method Summary
`DoubleGrid3D` | `add(double withThisMuch)` Sets each value in the grid to that value added to withThisMuch Returns the modified grid.
`DoubleGrid3D` | `add(DoubleGrid3D withThis)` Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid.
`DoubleGrid3D` | `add(IntGrid3D withThis)` Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid.
`DoubleGrid3D` | `ceiling()` Sets each value in the grid to ceil(value).
`DoubleGrid3D` | `floor()` Sets each value in the grid to floor(value).
`double` | `get(int x, int y, int z)` Returns the element at location (x,y,z)
`DoubleBag` | `getMooreNeighbors(int x, int y, int z, int dist, int mode, boolean includeOrigin, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y), abs(z-Z) ) <= dist.
`void` | `getNeighborsHamiltonianDistance(int x, int y, int z, int dist, boolean toroidal, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Deprecated.
`void` | `getNeighborsMaxDistance(int x, int y, int z, int dist, boolean toroidal, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Deprecated.
`DoubleBag` | `getRadialNeighbors(int x, int y, int z, int dist, int mode, boolean includeOrigin, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)`
`DoubleBag` | `getRadialNeighbors(int x, int y, int z, int dist, int mode, boolean includeOrigin, int measurementRule, boolean closed, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)`
`DoubleBag` | `getVonNeumannNeighbors(int x, int y, int z, int dist, int mode, boolean includeOrigin, DoubleBag result, IntBag xPos, IntBag yPos, IntBag zPos)` Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) + abs(z-Z) <= dist.
`DoubleGrid3D` | `lowerBound(double toNoLowerThanThisMuch)` Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.
`double` | `max()` Returns the maximum value stored in the grid
`double` | `mean()` Returns the mean value stored in the grid
`double` | `min()` Returns the minimum value stored in the grid
`DoubleGrid3D` | `multiply(double byThisMuch)` Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.
`DoubleGrid3D` | `multiply(DoubleGrid3D withThis)` Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid.
`DoubleGrid3D` | `multiply(IntGrid3D withThis)` Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid.
`DoubleGrid3D` | `rint()` Sets each value in the grid to rint(value).
`double` | `set(int x, int y, int z, double val)` Sets location (x,y,z) to val
`DoubleGrid3D` | `setTo(double thisMuch)` Sets all the locations in the grid the provided element
`DoubleGrid3D` | `setTo(DoubleGrid3D values)` Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.
`double[]` | `toArray()` Flattens the grid to a one-dimensional array, storing the elements in row-major order,including duplicates and null values.
`DoubleGrid3D` | `truncate()` Eliminates the decimal portion of each value in the grid (rounds towards zero).
`DoubleGrid3D` | `upperBound(double toNoMoreThanThisMuch)` Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch.

Methods inherited from class sim.field.grid.AbstractGrid3D
`buildMap, buildMap, getHeight, getLength, getMooreLocations, getNeighborsHamiltonianDistance, getNeighborsMaxDistance, getRadialLocations, getRadialLocations, getVonNeumannLocations, getWidth, removeOrigin, removeOriginToroidal, stx, sty, stz, stz, tx, ty, tz`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### field

    public double[][][] field

Constructor Detail

### DoubleGrid3D

    public DoubleGrid3D(int width,
                        int height,
                        int length)

### DoubleGrid3D

    public DoubleGrid3D(int width,
                        int height,
                        int length,
                        double initialValue)

### DoubleGrid3D

    public DoubleGrid3D(DoubleGrid3D values)

Method Detail

### set

    public final double set(int x,
                            int y,
                            int z,
                            double val)

  Sets location (x,y,z) to val

### get

    public final double get(int x,
                            int y,
                            int z)

  Returns the element at location (x,y,z)

### toArray

    public final double[] toArray()

  Flattens the grid to a one-dimensional array, storing the elements in row-major order,including duplicates and null values. Returns the grid.

### max

    public final double max()

  Returns the maximum value stored in the grid

### min

    public final double min()

  Returns the minimum value stored in the grid

### mean

    public final double mean()

  Returns the mean value stored in the grid

### setTo

    public final DoubleGrid3D setTo(double thisMuch)

  Sets all the locations in the grid the provided element

### setTo

    public final DoubleGrid3D setTo(DoubleGrid3D values)

  Changes the dimensions of the grid to be the same as the one provided, then sets all the locations in the grid to the elements at the quivalent locations in the provided grid.

### upperBound

    public final DoubleGrid3D upperBound(double toNoMoreThanThisMuch)

  Thresholds the grid so that values greater to toNoMoreThanThisMuch are changed to toNoMoreThanThisMuch. Returns the modified grid.

### lowerBound

    public final DoubleGrid3D lowerBound(double toNoLowerThanThisMuch)

  Thresholds the grid so that values smaller than toNoLowerThanThisMuch are changed to toNoLowerThanThisMuch Returns the modified grid.

### add

    public final DoubleGrid3D add(double withThisMuch)

  Sets each value in the grid to that value added to withThisMuch Returns the modified grid.

### add

    public final DoubleGrid3D add(IntGrid3D withThis)

  Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid. Returns the modified grid.

### add

    public final DoubleGrid3D add(DoubleGrid3D withThis)

  Sets the value at each location in the grid to that value added to the value at the equivalent location in the provided grid. Returns the modified grid.

### multiply

    public final DoubleGrid3D multiply(double byThisMuch)

  Sets each value in the grid to that value multiplied byThisMuch Returns the modified grid.

### multiply

    public final DoubleGrid3D multiply(IntGrid3D withThis)

  Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid. Returns the modified grid.

### multiply

    public final DoubleGrid3D multiply(DoubleGrid3D withThis)

  Sets the value at each location in the grid to that value multiplied by to the value at the equivalent location in the provided grid. Returns the modified grid.

### floor

    public final DoubleGrid3D floor()

  Sets each value in the grid to floor(value). Returns the modified grid.

### ceiling

    public final DoubleGrid3D ceiling()

  Sets each value in the grid to ceil(value). Returns the modified grid.

### truncate

    public final DoubleGrid3D truncate()

  Eliminates the decimal portion of each value in the grid (rounds towards zero). Returns the modified grid.

### rint

    public final DoubleGrid3D rint()

  Sets each value in the grid to rint(value). That is, each value is rounded to the closest integer value. If two integers are the same distance, the value is rounded to the even integer. Returns the modified grid.

### getNeighborsMaxDistance

    public void getNeighborsMaxDistance(int x,
                                        int y,
                                        int z,
                                        int dist,
                                        boolean toroidal,
                                        DoubleBag result,
                                        IntBag xPos,
                                        IntBag yPos,
                                        IntBag zPos)

  Deprecated.

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y), abs(z-Z) ) <= dist. This region forms a cube 2*dist+1 cells across, centered at (X,Y,Z). If dist==1, this is equivalent to the twenty-six neighbors surrounding (X,Y,Z), plus (X,Y) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  Then places into the result DoubleBag any Objects which fall on one of these locations, clearning it first. Returns the result DoubleBag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0,0) to (width, height, length), that is, the width and height and length of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y,z) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsMaxDistance(x,y,z,dist,toroidal ? Grid3D.TOROIDAL : Grid3D.BOUNDED, true, result, xPos, yPos,zPos);`

### getMooreNeighbors

    public DoubleBag getMooreNeighbors(int x,
                                       int y,
                                       int z,
                                       int dist,
                                       int mode,
                                       boolean includeOrigin,
                                       DoubleBag result,
                                       IntBag xPos,
                                       IntBag yPos,
                                       IntBag zPos)

  Gets all neighbors of a location that satisfy max( abs(x-X) , abs(y-Y), abs(z-Z) ) <= dist. This region forms a cube 2*dist+1 cells across, centered at (X,Y,Z). If dist==1, this is equivalent to the twenty-six neighbors surrounding (X,Y,Z), plus (X,Y) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  Then places into the result DoubleBag any Objects which fall on one of these locations, clearning it first. Returns the result DoubleBag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid3D.BOUNDED, Grid3D.UNBOUNDED, and Grid3D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid3D permits this but ObjectGrid3D and DoubleGrid3D and IntGrid3D and DenseGrid3D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y,z) point at the center of the neighborhood -- in the neighborhood results.

### getNeighborsHamiltonianDistance

    public void getNeighborsHamiltonianDistance(int x,
                                                int y,
                                                int z,
                                                int dist,
                                                boolean toroidal,
                                                DoubleBag result,
                                                IntBag xPos,
                                                IntBag yPos,
                                                IntBag zPos)

  Deprecated.

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) + abs(z-Z) <= dist. This region forms an octohedron 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y,Y). If dist==1 this is equivalent to the six neighbors above, below, left, and right, front, and behind (X,Y,Z)), plus (X,Y,Z) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  Then places into the result DoubleBag any Objects which fall on one of these locations, clearning it first. Returns the result DoubleBag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may only run in two modes: toroidal or bounded. Unbounded lookup is not permitted, and so this function is deprecated: instead you should use the other version of this function which has more functionality. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0,0) to (width, height, length), that is, the width and height and length of the grid. if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  The origin -- that is, the (x,y,z) point at the center of the neighborhood -- is always included in the results.

  This function is equivalent to: `getNeighborsHamiltonianDistance(x,y,z,dist,toroidal ? Grid3D.TOROIDAL : Grid3D.BOUNDED, true, result, xPos, yPos,zPos);`

### getVonNeumannNeighbors

    public DoubleBag getVonNeumannNeighbors(int x,
                                            int y,
                                            int z,
                                            int dist,
                                            int mode,
                                            boolean includeOrigin,
                                            DoubleBag result,
                                            IntBag xPos,
                                            IntBag yPos,
                                            IntBag zPos)

  Gets all neighbors of a location that satisfy abs(x-X) + abs(y-Y) + abs(z-Z) <= dist. This region forms an octohedron 2*dist+1 cells from point to opposite point inclusive, centered at (X,Y,Y). If dist==1 this is equivalent to the six neighbors above, below, left, and right, front, and behind (X,Y,Z)), plus (X,Y,Z) itself. Places each x, y, and z value of these locations in the provided IntBags xPos, yPos, and zPos, clearing the bags first. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  Then places into the result DoubleBag any Objects which fall on one of these locations, clearning it first. Returns the result DoubleBag. null may be passed in for the various bags, though it is more efficient to pass in a 'scratch bag' for each one.

  This function may be run in one of three modes: Grid3D.BOUNDED, Grid3D.UNBOUNDED, and Grid3D.TOROIDAL. If "bounded", then the neighbors are restricted to be only those which lie within the box ranging from (0,0,0) to (width, height), that is, the width and height of the grid. If "unbounded", then the neighbors are not so restricted. Note that unbounded neighborhood lookup only makes sense if your grid allows locations to actually be outside this box. For example, SparseGrid3D permits this but ObjectGrid3D and DoubleGrid3D and IntGrid3D and DenseGrid3D do not. Finally if "toroidal", then the environment is assumed to be toroidal, that is, wrap-around, and neighbors are computed in this fashion. Toroidal locations will not appear multiple times: specifically, if the neighborhood distance is so large that it wraps completely around the width or height of the box, neighbors will not be counted multiple times. Note that to ensure this, subclasses may need to resort to expensive duplicate removal, so it's not suggested you use so unreasonably large distances.

  You can also opt to include the origin -- that is, the (x,y,z) point at the center of the neighborhood -- in the neighborhood results.

### getRadialNeighbors

    public DoubleBag getRadialNeighbors(int x,
                                        int y,
                                        int z,
                                        int dist,
                                        int mode,
                                        boolean includeOrigin,
                                        DoubleBag result,
                                        IntBag xPos,
                                        IntBag yPos,
                                        IntBag zPos)

### getRadialNeighbors

    public DoubleBag getRadialNeighbors(int x,
                                        int y,
                                        int z,
                                        int dist,
                                        int mode,
                                        boolean includeOrigin,
                                        int measurementRule,
                                        boolean closed,
                                        DoubleBag result,
                                        IntBag xPos,
                                        IntBag yPos,
                                        IntBag zPos)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD